Index: /orxonox/trunk/src/lib/graphics/graphics_engine.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/graphics_engine.cc	(revision 4618)
+++ /orxonox/trunk/src/lib/graphics/graphics_engine.cc	(revision 4619)
@@ -95,6 +95,4 @@
   this->setResolution(800, 600, 16);
 
-  // Set window labeling
-  SDL_WM_SetCaption ("Orxonox " PACKAGE_VERSION, "Orxonox " PACKAGE_VERSION);
 
   // TO DO: Create a cool icon and use it here
@@ -106,4 +104,17 @@
   glEnable(GL_DEPTH_TEST);
 }
+
+
+/**
+ * sets the Window Captions and the Name of the icon.
+ * @param windowName The name of the Window
+ * @param icon The name of the Icon on the Disc
+ */
+void GraphicsEngine::setWindowName(const char* windowName, const char* icon)
+{
+  // Set window labeling
+  SDL_WM_SetCaption (windowName, icon);
+}
+
 
 /**
Index: /orxonox/trunk/src/lib/graphics/graphics_engine.h
===================================================================
--- /orxonox/trunk/src/lib/graphics/graphics_engine.h	(revision 4618)
+++ /orxonox/trunk/src/lib/graphics/graphics_engine.h	(revision 4619)
@@ -1,5 +1,5 @@
-/*! 
+/*!
     \file graphics_engine.h
-    
+
     \brief defines a Interface between orxonox and graphical input
 
@@ -21,58 +21,64 @@
 /**
    handles graphical SDL-initialisation, textures, resolutions, and so on
-*/   
-class GraphicsEngine : public BaseObject 
+ */
+class GraphicsEngine : public BaseObject
 {
- public:
-  virtual ~GraphicsEngine();
-  /** \returns a Pointer to the only object of this Class */
-  inline static GraphicsEngine* getInstance(void) { if (!singletonRef) singletonRef = new GraphicsEngine();  return singletonRef; };
+  public:
+    virtual ~GraphicsEngine();
+    /** \returns a Pointer to the only object of this Class */
+    inline static GraphicsEngine* getInstance(void) { if (!singletonRef) singletonRef = new GraphicsEngine();  return singletonRef; };
 
-  int initVideo();
-  int setGLattribs(void);
-  int setResolution(int width, int height, int bpp);
-  void setFullscreen(bool fullscreen = false);
-  static void setBackgroundColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha = 1.0);
+    int initVideo();
 
-  /** \returns the x resolution */
-  inline int getResolutionX(void) const {return this->resolutionX;}
-  /** \returns the y resolution */
-  inline int getResolutionY(void) const {return this->resolutionY;}
-  /** \returns the Bits Per Pixel */
-  inline int getbbp(void) const {return this->bitsPerPixel;}
-  int resolutionChanged(SDL_ResizeEvent* resizeInfo);
-  void listModes(void);
+    void setWindowName(const char* windowName, const char* icon);
+    int setGLattribs(void);
+    int setResolution(int width, int height, int bpp);
+    void setFullscreen(bool fullscreen = false);
+    static void setBackgroundColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha = 1.0);
 
-  static bool texturesEnabled;
+    /** \returns the x resolution */
+    inline int getResolutionX(void) const { return this->resolutionX; };
+    /** \returns the y resolution */
+    inline int getResolutionY(void) const { return this->resolutionY; };
+    /** \returns the Bits Per Pixel */
+    inline int getbbp(void) const { return this->bitsPerPixel; };
 
-  static void enter2DMode(void);
-  static void leave2DMode(void);
+    int resolutionChanged(SDL_ResizeEvent* resizeInfo);
 
-  static void storeMatrices(void);
-  static GLdouble modMat[16];
-  static GLdouble projMat[16];
-  static GLint viewPort[4];
-  
-  void tick(float dt);
-  void displayFPS(bool display);
+    static void enter2DMode(void);
+    static void leave2DMode(void);
 
+    static void storeMatrices(void);
+    static GLdouble modMat[16];
+    static GLdouble projMat[16];
+    static GLint viewPort[4];
 
- private:
-  GraphicsEngine();
-  static GraphicsEngine* singletonRef;
+    void tick(float dt);
+    void displayFPS(bool display);
 
- private:
-  SDL_Surface*   screen;          //!< the screen we draw to
-  int            resolutionX;     //!< the X-resoultion of the screen
-  int            resolutionY;     //!< the Y-resolution of the screen
-  int            bitsPerPixel;    //!< the bits per pixels of the screen
-  bool           fullscreen;      //!< if we are in fullscreen mode
-  Uint32         videoFlags;      //!< flags for video
-  SDL_Rect**     videoModes;      //!< list of resolutions
-  
-  bool           bDisplayFPS;     //!< is true if the fps should be displayed
-  float          currentFPS;      //!< the current frame rate: frames per seconds
-  float          maxFPS;          //!< maximal frame rate we ever got since start of the game
-  float          minFPS;          //!< minimal frame rate we ever got since start
+    void listModes(void);
+
+  public:
+    static bool texturesEnabled;
+
+  private:
+    GraphicsEngine();
+
+  private:
+    static GraphicsEngine* singletonRef;
+
+    SDL_Surface*   screen;          //!< the screen we draw to
+    int            resolutionX;     //!< the X-resoultion of the screen
+    int            resolutionY;     //!< the Y-resolution of the screen
+    int            bitsPerPixel;    //!< the bits per pixels of the screen
+    bool           fullscreen;      //!< if we are in fullscreen mode
+    Uint32         videoFlags;      //!< flags for video
+    SDL_Rect**     videoModes;      //!< list of resolutions
+
+    bool           bDisplayFPS;     //!< is true if the fps should be displayed
+    float          currentFPS;      //!< the current frame rate: frames per seconds
+    float          maxFPS;          //!< maximal frame rate we ever got since start of the game
+    float          minFPS;          //!< minimal frame rate we ever got since start
+
 
 #ifndef NO_TEXT
Index: /orxonox/trunk/src/orxonox.cc
===================================================================
--- /orxonox/trunk/src/orxonox.cc	(revision 4618)
+++ /orxonox/trunk/src/orxonox.cc	(revision 4619)
@@ -144,4 +144,5 @@
 
   GraphicsEngine::getInstance();
+  GraphicsEngine::getInstance()->setWindowName("orxonox " PACKAGE_VERSION, "orxonox " PACKAGE_VERSION);
 
   return 0;
Index: /orxonox/trunk/src/subprojects/collision_detection/collision_detection.cc
===================================================================
--- /orxonox/trunk/src/subprojects/collision_detection/collision_detection.cc	(revision 4618)
+++ /orxonox/trunk/src/subprojects/collision_detection/collision_detection.cc	(revision 4619)
@@ -31,9 +31,9 @@
 {
   CDEngine::getInstance();
-  CDEngine::getInstance()->debug();
+  //CDEngine::getInstance()->debug();
 
-  //model = new MD2Model("models/tris.md2", "models/tris.pcx");
-  //model->tick(0.1f);
-  //CDEngine::getInstance()->debugSpawnTree(2, model->data->pVertices, model->data->numVertices);
+  model = new MD2Model("models/tris.md2", "models/tris.pcx");
+  model->tick(0.1f);
+  CDEngine::getInstance()->debugSpawnTree(1, model->data->pVertices, model->data->numVertices);
 
   LightManager* lightMan = LightManager::getInstance();
@@ -70,5 +70,5 @@
   LightManager::getInstance()->draw();
 
-  //model->draw();
+  model->draw();
 }
 