Index: data/trunk/levels/DefaultCampaign.oxc
===================================================================
--- data/trunk/levels/DefaultCampaign.oxc	(revision 4620)
+++ data/trunk/levels/DefaultCampaign.oxc	(revision 4621)
@@ -30,6 +30,6 @@
     <SinglePlayerWorld>
       <identifier>3</identifier>
-      <nextid>2</nextid>
-      <name>In Space</name>
+      <nextid>3</nextid>
+      <name>Mission 1</name>
       <path>levels/vertical_scroller.oxw</path>
       <menu-entry>1</menu-entry>
@@ -38,4 +38,12 @@
     <SinglePlayerWorld>
       <identifier>4</identifier>
+      <nextid>2</nextid>
+      <name>Noxon Encounter</name>
+      <path>levels/vertical_scroller2.oxw</path>
+      <menu-entry>1</menu-entry>
+    </SinglePlayerWorld>
+
+    <SinglePlayerWorld>
+      <identifier>5</identifier>
       <nextid>1</nextid>
       <name>Cut Scene</name>
Index: data/trunk/levels/vertical_scroller.oxw
===================================================================
--- data/trunk/levels/vertical_scroller.oxw	(revision 4620)
+++ data/trunk/levels/vertical_scroller.oxw	(revision 4621)
@@ -1,4 +1,4 @@
 <WorldDataFile>
-  <name>In Space</name>
+  <name>Mission 1</name>
   <description>This is the vertical scroller level.</description>
   <menu-item-image>textures/menu/Scienceproject_512x512.jpg</menu-item-image>
@@ -90,12 +90,24 @@
     <NPC>
       <name>Pirate01</name>
-      <model>models/spaceships/noxon_spaceship_fighter.obj,0.2</model>
+      <model>models/spaceships/pirates_spaceship_fighter.obj,0.2</model>
+      <enableAI></enableAI>
+      <team>1</team>
+      <swarm>1</swarm>
+      <attackDistance>100</attackDistance>
+      <maxSpeed>50</maxSpeed>
+      <Weapons>LaserCannon</Weapons>
       <abs-coor>3500, 0, 20</abs-coor>
-      <abs-dir> 3.14,0,1,0 </abs-dir>
+      <rotation>0,1,0</rotation>
     </NPC>
 
     <NPC>
       <name>Pirate02</name>
-      <model>models/spaceships/noxon_spaceship_fighter.obj,0.2</model>
+      <model>models/spaceships/pirates_spaceship_fighter.obj,0.2</model>
+      <enableAI></enableAI>
+      <team>1</team>
+      <swarm>1</swarm>
+      <attackDistance>100</attackDistance>
+      <maxSpeed>50</maxSpeed>
+      <Weapons>HeavyBlaster</Weapons>
       <abs-coor>3500, 0, 0</abs-coor>
       <abs-dir> 3.14,0,1,0 </abs-dir>
@@ -104,5 +116,11 @@
     <NPC>
       <name>Pirate03</name>
-      <model>models/spaceships/noxon_spaceship_fighter.obj,0.2</model>
+      <model>models/spaceships/pirates_spaceship_fighter.obj,0.2</model>
+      <enableAI></enableAI>
+      <team>1</team>
+      <swarm>1</swarm>
+      <attackDistance>100</attackDistance>
+      <maxSpeed>50</maxSpeed>
+      <Weapons>HeavyBlaster</Weapons>
       <abs-coor>3450, 0, 10</abs-coor>
       <abs-dir> 3.14,0,1,0 </abs-dir>
Index: data/trunk/levels/vertical_scroller2.oxw
===================================================================
--- data/trunk/levels/vertical_scroller2.oxw	(revision 4621)
+++ data/trunk/levels/vertical_scroller2.oxw	(revision 4621)
@@ -0,0 +1,171 @@
+<WorldDataFile>
+  <name>Noxon Encounter</name>
+  <description>This is the second half of the vertical scroller level.</description>
+  <menu-item-image>textures/menu/Scienceproject_512x512.jpg</menu-item-image>
+  <screenshoot>textures/menu/Scienceproject_512x512.jpg</screenshoot>
+
+  <LoadScreen>
+    <BackgroundImage>textures/load_screens/ambush.png</BackgroundImage>
+
+    <ElementCount>16</ElementCount>
+    <BackgroundPS>0,0,1.0,1</BackgroundPS>
+    <BarPS>.65,.87,.3,.05</BarPS>
+    <BarImage>textures/load_screens/ambush-loadbar.png</BarImage>
+  </LoadScreen>
+
+  <clip-region>1, 100000</clip-region>
+
+  <WorldEntities>
+    <Building>
+
+    <Rotor>
+      <name>meteorit01</name>
+      <model>models/planets/asteroid_FA48.obj, 20</model>
+      <abs-coor>1100,-100,30</abs-coor>
+      <rotation>0,2,0</rotation>
+      <Size>100</Size>
+    </Rotor>
+
+    <Rotor>
+      <name>meteorit02</name>
+      <model>models/planets/asteroid_FA48.obj, 20</model>
+      <abs-coor>1500,-200,40</abs-coor>
+      <rotation>0,0,3</rotation>
+      <Size>100</Size>
+    </Rotor>
+
+    <Rotor>
+      <name>meteorit03</name>
+      <model>models/planets/asteroid_FA108.obj, 25</model>
+      <abs-coor>1700,-1000,-10</abs-coor>
+      <rotation>4,2,1</rotation>
+      <Size>100</Size>
+    </Rotor>
+
+    <Rotor>
+      <name>meteorit04</name>
+      <model>models/planets/asteroid_FA108.obj, 20</model>
+      <abs-coor>2300,-500,-10</abs-coor>
+      <rotation>0,2,1</rotation>
+      <Size>100</Size>
+    </Rotor>
+
+    <Rotor>
+      <name>meteorit05</name>
+      <model>models/planets/asteroid_FA48.obj, 10</model>
+      <abs-coor>2200,-50,50</abs-coor>
+      <rotation>5,0,1</rotation>
+      <Size>100</Size>
+    </Rotor>
+
+    <Rotor>
+      <name>meteorit06</name>
+      <model>models/planets/asteroid_FA48.obj, 5</model>
+      <abs-coor>2000,-50,0</abs-coor>
+      <rotation>0,3,5</rotation>
+      <Size>100</Size>
+    </Rotor>
+
+    <Rotor>
+      <name>meteorit07</name>
+      <model>models/planets/asteroid_FA108.obj, 20</model>
+      <abs-coor>3100,-500,15</abs-coor>
+      <rotation>1,2,0</rotation>
+      <Size>100</Size>
+    </Rotor>
+
+    <Rotor>
+      <name>meteorit08</name>
+      <model>models/planets/asteroid_FA108.obj, 20</model>
+      <abs-coor>3400,-500,-30</abs-coor>
+      <rotation>0,5,0</rotation>
+      <Size>100</Size>
+    </Rotor>
+
+    <NPC>
+      <name>Pirate01</name>
+      <model>models/spaceships/noxon_spaceship_fighter.obj,0.2</model>
+      <abs-coor>3500, 0, 20</abs-coor>
+
+    </NPC>
+
+    <NPC>
+      <name>Pirate02</name>
+      <model>models/spaceships/noxon_spaceship_fighter.obj,0.2</model>
+      <abs-coor>3500, 0, 0</abs-coor>
+      <abs-dir> 3.14,0,1,0 </abs-dir>
+    </NPC>
+
+    <NPC>
+      <name>Pirate03</name>
+      <model>models/spaceships/noxon_spaceship_fighter.obj,0.2</model>
+      <abs-coor>3450, 0, 10</abs-coor>
+      <abs-dir> 3.14,0,1,0 </abs-dir>
+    </NPC>
+
+    <SpaceShip>
+      <name>Player</name>
+      <model>models/spaceships/human_spaceship_fighter.obj, 0.4</model>
+      <abs-coor>0,0,0</abs-coor>
+      <playmode>Horizontal</playmode>
+     <drawTrack>1</drawTrack>
+      <Track>
+        <mode>0</mode>
+        <speed>50</speed>
+        <addPoint>0,0,0</addPoint>
+        <addPoint>1000,0,400</addPoint>
+        <addPoint>2000,0,0</addPoint>
+        <addPoint>3000,0,-400</addPoint>
+        <addPoint>4000,0,0</addPoint>
+        <addPoint>5000,0,400</addPoint>
+        <addPoint>6000,0,0</addPoint>
+        <addPoint>7000,0,-400</addPoint>
+      </Track>
+    </SpaceShip>
+
+   <SkyBox>
+      <name>Sky</name>
+      <Materialset>textures/sky/simple_space</Materialset>
+      <Size>100000</Size>
+    </SkyBox>
+  </WorldEntities>
+
+  <LightManager>
+    <Lights>
+      <Light>
+       <diffuse-color>1,1,1</diffuse-color>
+       <abs-coor>100,1000,50</abs-coor>
+       <parent>Player</parent>
+      </Light>
+      <Light>
+       <diffuse-color>1,1,1</diffuse-color>
+       <abs-coor>3000,1000,1700</abs-coor>
+       <parent>Player</parent>
+      </Light>
+    </Lights>
+    <ambient-color>1,1,1</ambient-color>
+  </LightManager>
+
+  <ScriptManager> 
+   <Scripts>
+
+    <Script>
+     <file>vertical_scroller/vs2.lua</file>
+    </Script>
+
+   </Scripts>
+
+  </ScriptManager>
+
+   <CameraMan>
+    <name> cameraManager </name>
+    <Cameras>
+     <Camera>
+      <name> CameraOne </name>
+      <abs-coor>2800,5,50</abs-coor>
+     </Camera>
+    </Cameras>
+   </CameraMan>
+
+
+</WorldDataFile>
Index: data/trunk/scripts/vertical_scroller/vs1.lua
===================================================================
--- data/trunk/scripts/vertical_scroller/vs1.lua	(revision 4620)
+++ data/trunk/scripts/vertical_scroller/vs1.lua	(revision 4621)
@@ -2,5 +2,5 @@
 thisscript:addObject("SpaceShip", "Player")
 thisscript:addObject("CameraMan", "cameraManager")
--- thisscript:addObjectAsName("GameWorld", "In Space", "gameWorld")
+-- thisscript:addObjectAsName("GameWorld", "Mission 1", "gameWorld")
 
 triggerInit = ScriptTrigger()
@@ -13,7 +13,7 @@
 triggerCutscene:setScript("vs1.lua")
 triggerCutscene:setFunction("startSequence")
-triggerCutscene:setRadius(30)
+triggerCutscene:setRadius(50)
 triggerCutscene:setTarget("Player")
-triggerCutscene:setAbsCoor(0 , 0 , 0)
+triggerCutscene:setAbsCoor(100 , 0 , 0)
 triggerCutscene:setDebugDraw(true)
 triggerCutscene:setActiveOnCreation(false)
@@ -23,7 +23,10 @@
 
 function init(timestep)
+-- cameraManager:setCam("GameWorld-Camera")
+cameraManager:atachCameraToWorldEntity("CameraOne", "NPC", "Pirate01")
 
-cameraManager:atachCameraToWorldEntity("CameraOne", "NPC", "Pirate01")
 cameraManager:changeTarget("CameraOne", "NPC", "Pirate01")
+cameraManager:jumpCam("CameraOne", 3400, 0, 50)
+
 
 
@@ -34,6 +37,7 @@
 
 cameraManager:setCam("CameraOne")
-cameraManager:changeCurrTarget("NPC", "Pirate01")
-cameraManager:atachCurrCameraToWorldEntity("NPC", "Pirate01")
+-- gameWorld:showText("Kill those traitorous bastards")
+-- cameraManager:changeCurrTarget("NPC", "Pirate01")
+-- cameraManager:atachCurrCameraToWorldEntity("NPC", "Pirate01")
 
 return true