Index: orxonox/trunk/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- orxonox/trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 4628)
+++ orxonox/trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 4629)
@@ -73,5 +73,5 @@
 void OBBTreeNode::spawnBVTree(const int depth, sVec3D *verticesList, const int length)
 {
-  printf("OBB Depth: %i\n", depth);
+  printf("OBB Depth: %i, numVertices: %i\n", depth, length);
   this->depth = depth;
 
@@ -159,15 +159,15 @@
 //   }
 
-  printf("\nCovariance Matrix:\n");
-  for(int j = 0; j < 3; ++j)
-  {
-    printf(" |");
-    for(int k = 0; k < 3; ++k)
-    {
-      printf(" \b%f ", covariance[j][k]);
-    }
-    printf(" |\n");
-  }
-  printf("center: %f, %f, %f\n\n", center.x, center.y, center.z);
+//   printf("\nCovariance Matrix:\n");
+//   for(int j = 0; j < 3; ++j)
+//   {
+//     printf(" |");
+//     for(int k = 0; k < 3; ++k)
+//     {
+//       printf(" \b%f ", covariance[j][k]);
+//     }
+//     printf(" |\n");
+//   }
+//   printf("center: %f, %f, %f\n\n", center.x, center.y, center.z);
 
 
@@ -188,22 +188,8 @@
   vectors
   */
-  Matrix                V(3,3);                               //!< for eigenvectors
-  DiagonalMatrix        D(3);                                 //!< for eigenvalues
-  SymmetricMatrix       C(3);                                 //!< for the covariance symmetrical matrix
+ /* Matrix                V(3,3);    */                           //!< for eigenvectors
+ /* DiagonalMatrix        D(3);   */                              //!< for eigenvalues
+/*  SymmetricMatrix       C(3); */                                //!< for the covariance symmetrical matrix
   Vector**              axis = new Vector*[3];                //!< the references to the obb axis
-
-
-  C(1,1) = covariance[0][0];
-  C(1,2) = covariance[0][1];
-  C(1,3) = covariance[0][2];
-  C(2,1) = covariance[1][0];
-  C(2,2) = covariance[1][1];
-  C(2,3) = covariance[1][2];
-  C(3,1) = covariance[2][0];
-  C(3,2) = covariance[2][1];
-  C(3,3) = covariance[2][2];
-
-  Jacobi(C, D, V);                                            /* do the jacobi decomposition */
-  PRINTF(0)("-- Done Jacobi Decomposition\n");
 
 
@@ -231,42 +217,38 @@
 
 
-//   EVJacobi jac;
-//   jac.setMatrix(2, covariance, 0, 0);
-//   jac.getEigenVector(eigenvectors);
-//
-
   JacobI(a, 3, eigval, b, rot);
-
-  printf("Old Jacobi\n");
-  for(int j = 1; j < 4; ++j)
-  {
-    printf(" |");
-    for(int k = 1; k < 4; ++k)
-    {
-      printf(" \b%f ", V(j, k));
-    }
-    printf(" |\n");
-  }
-
-  printf("New Jacobi\n");
-  for(int j = 1; j < 4; ++j)
-  {
-    printf(" |");
-    for(int k = 1; k < 4; ++k)
-    {
-      printf(" \b%f ", b[j][k]);
-    }
-    printf(" |\n");
-  }
-
-  axis[0] = new Vector(V(1, 1), V(2, 1), V(3, 1));
-  axis[1] = new Vector(V(1, 2), V(2, 2), V(3, 2));
-  axis[2] = new Vector(V(1, 3), V(2, 3), V(3, 3));
+  PRINTF(0)("-- Done Jacobi Decomposition\n");
+
+
+
+//   printf("Jacobi\n");
+//   for(int j = 1; j < 4; ++j)
+//   {
+//     printf(" |");
+//     for(int k = 1; k < 4; ++k)
+//     {
+//       printf(" \b%f ", b[j][k]);
+//     }
+//     printf(" |\n");
+//   }
+
+  axis[0] = new Vector(b[1][1], b[2][1], b[3][1]);
+  axis[1] = new Vector(b[1][2], b[2][2], b[3][2]);
+  axis[2] = new Vector(b[1][3], b[2][3], b[3][3]);
   box->axis = axis;
   PRINTF(0)("-- Got Axis\n");
 
-//   delete &V;
-//   delete &D;
-//   delete &V;
+  delete [] a[0];
+  delete [] a[1];
+  delete [] a[2];
+  delete [] a[3];
+  delete [] a;
+
+  delete [] b[0];
+  delete [] b[1];
+  delete [] b[2];
+  delete [] b[3];
+  delete [] b;
+
 
 //   printf("\neigenvector: %f, %f, %f\n", box->axis[0]->x, box->axis[0]->y, box->axis[0]->z);
@@ -339,5 +321,5 @@
   }
 
-  printf("\nlongest axis is: nr %i with a half-length of: %f\n", axisIndex, aLength);
+//   printf("\nlongest axis is: nr %i with a half-length of: %f\n", axisIndex, aLength);
 
 
@@ -358,5 +340,5 @@
   }
 
-  printf("\nthe clostest vertex is nr: %i, with a dist of: %f\n", vertexIndex ,dist);
+//   printf("\nthe clostest vertex is nr: %i, with a dist of: %f\n", vertexIndex ,dist);
 
 
@@ -377,5 +359,5 @@
   partition1.add(&box->vertices[vertexIndex]);
 
-  printf("\npartition1: got %i vertices/ partition 2: got %i vertices\n", partition1.getSize(), partition2.getSize());
+//   printf("\npartition1: got %i vertices/ partition 2: got %i vertices\n", partition1.getSize(), partition2.getSize());
 
 
Index: orxonox/trunk/src/subprojects/collision_detection/collision_detection.cc
===================================================================
--- orxonox/trunk/src/subprojects/collision_detection/collision_detection.cc	(revision 4628)
+++ orxonox/trunk/src/subprojects/collision_detection/collision_detection.cc	(revision 4629)
@@ -35,5 +35,5 @@
   model = new MD2Model("models/tris.md2", "models/tris.pcx");
   model->tick(0.1f);
-  CDEngine::getInstance()->debugSpawnTree(1, model->data->pVertices, model->data->numVertices);
+  CDEngine::getInstance()->debugSpawnTree(2, model->data->pVertices, model->data->numVertices);
 
 